<?php

namespace App\Http\Controllers\Gateway\OneCash;

use App\Models\Deposit;
use App\Models\GeneralSetting;
use App\Http\Controllers\Gateway\PaymentController;
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

class ProcessController extends Controller
{

    public static function process($deposit)
    {
        $cashAcc = json_decode($deposit->gatewayCurrency()->gateway_parameter);
        $parameters = [
            'identifier' => $deposit->trx,
            'currency' => $deposit->method_currency,
            // 'amount' => $deposit->amount,
            'amount' => $deposit->final_amo,
            'details' => ' Deposit amount ' .$deposit->amount. ' by '. \Auth::user()->email,
            'ipn_url' => route('ipn.'.$deposit->gateway->alias),
            'cancel_url' => route(gatewayRedirectUrl()),
            'success_url' => route(gatewayRedirectUrl(true)),
            'public_key' => $cashAcc->publishable_key,
            'site_logo' => 'https://www.onecashpk.com/assets/images/logoIcon/light_logo.png',
            'checkout_theme' => 'light',
            'customer_name' => \Auth::user()->username,
            'customer_email' => \Auth::user()->email,
	   ];
        

	      //end point
    	  $url = 'https://www.onecashpk.com/payment/initiate';
    	
    	  $ch = curl_init();
    	  curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
    	  curl_setopt($ch, CURLOPT_URL, $url);
    	  curl_setopt($ch, CURLOPT_POSTFIELDS,  $parameters);
    	  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    	  $result = curl_exec($ch);
    	  $result  = json_decode($result, true);
    	  
    	  if(isset($result['error'])){
    	      if($result['error']=='true'){
        	       $parameters['error'] = 'true';
                   $parameters['message'] = $result['message'];
    	           return json_encode($parameters);
    	      }
    	      elseif($result['error']=='yes'){
    	           $parameters['error'] = 'true';
                   $parameters['message'] = $result['errors'];
    	          return json_encode($parameters);
    	      }
    	  }
    	  elseif(isset($result['success'])){
    	      if($result['success']=='ok'){
            	   $parameters['redirect'] = true;
                   $parameters['redirect_url'] = $result['url'];
                   return json_encode($parameters);
    	      }
    	  }
    }
    
    public function ipn()
    {
        $status = $_POST['status'];
        $trx= $_POST['identifier'];
       if($status == "success"){
            $deposit = Deposit::where('trx', $trx)->orderBy('id', 'DESC')->first();
            $cashAcc = json_decode($deposit->gatewayCurrency()->gateway_parameter);
            PaymentController::userDataUpdate($trx);
            $notify[] = ['success', 'Transaction is successful'];
            return to_route(gatewayRedirectUrl(true))->withNotify($notify);
        }
        else {
             $notify[] = ['error', 'Payment failed'];
        }
         
    }
}
